//==============================================================================
//	File:      $URL: svn+ssh://repositorypub@repository.eecs.berkeley.edu/public/Projects/GateLib/branches/dev/Publications/Tutorials/Publications/EECS150/Labs/StructuralVerilog/Files/ALUBitSlice.v $
//	Version:   $Revision: 26904 $
//	Author:    John Wawrzynek
//			  Chris Fletcher (http://cwfletcher.net)
//	Copyright: Copyright 2009-2010 UC Berkeley
//==============================================================================

//==============================================================================
//	Section:	License
//==============================================================================
//	Copyright (c) 2005-2010, Regents of the University of California
//	All rights reserved.
//
//	Redistribution and use in source and binary forms, with or without modification,
//	are permitted provided that the following conditions are met:
//
//		- Redistributions of source code must retain the above copyright notice,
//			this list of conditions and the following disclaimer.
//		- Redistributions in binary form must reproduce the above copyright
//			notice, this list of conditions and the following disclaimer
//			in the documentation and/or other materials provided with the
//			distribution.
//		- Neither the name of the University of California, Berkeley nor the
//			names of its contributors may be used to endorse or promote
//			products derived from this software without specific prior
//			written permission.
//
//	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
//	ANY EXPRESS OR InIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE InIMPLIED
//	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
//	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
//	ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==============================================================================

//------------------------------------------------------------------------------
//	Module:	ALUBitSlice
//	Desc:	A 1-bit ALU.  This ALU is is capable of: +, -, & (and), | (or), 
//			^ (xor), ~ (not), and passthrough.  If set to + or -, the CarryIn 
//			and CarryOut lines must be set appropriately.
//	Inputs:	A: The first input.
//			B: The second input.
//			CarryIn: The carry-in for addition/subtraction.
//			ALUOp: The ALU opmode selector.  This ALU uses the following encoding 
//				(you MUST follow this encoding for the test harness to interface 
//				correctly with your implementation!):
//					000:	Result = A + B 
//					001: Result = A - B
//					010: Result = A & B
//					011: Result =  A | B
//					100: Result = A ^ B
//					101: Result = ~A
//					110: Result = A
//					111: Not used
//	Outputs:	Result: The output.
//			CarryOut: The carry-out for addition/subtraction.
//
//	Author:  John Wawrzynek
//			<a href="http://cwfletcher.net">Chris Fletcher</a>
//	Version: $Revision: 26904 $
//------------------------------------------------------------------------------
module ALUBitSlice(
			//------------------------------------------------------------------
			//	Input Interface
			//------------------------------------------------------------------
			A,
			B,
			CarryIn,
			ALUOp,
			//------------------------------------------------------------------
			
			//------------------------------------------------------------------
			//	Output Interface
			//------------------------------------------------------------------
			Result,
			CarryOut
			//------------------------------------------------------------------
			);
	//--------------------------------------------------------------------------
	//	Inputs
	//--------------------------------------------------------------------------
	input wire										A, B, CarryIn;
	input wire 		[2:0]							ALUOp;
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	//	Outputs
	//--------------------------------------------------------------------------
	output wire										Result, CarryOut;
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	// Structural ALUBitSlice
	//--------------------------------------------------------------------------
	/* 
	
		Implement your ALUBitSlice here.
		
		You may only declare wires, instantiate simple modules/gates and use the 
		Verilog 'generate' statement.

		Good luck!
	
	*/
	//--------------------------------------------------------------------------
endmodule
//------------------------------------------------------------------------------